Generator = require('./generators.js').Generator;
Semantic = require('./semantics.js').Semantic;
module.exports = {
  contexts: [{"action": "create", "marker": "create", "klass": {"marker": "tankConcept", "word": "tank", "number": 1}}, {"action": "move", "marker": "move", "thing": {"pullFromContext": true, "language": "english", "marker": "anyConcept", "word": "it", "types": ["tankConcept"]}, "place": {"id": "building1", "language": "english", "marker": "buildingConcept", "word": "building1"}}],
  objects: {           newTank:() => { return { name: 'tank1', 'id': 'tank1id' } },
           },
  expected: ["create 1 tank", "move tank1 to building1"],
  expected_semantics: [{"action": "create", "klass": {"marker": "tankConcept", "number": 1, "word": "tank"}, "marker": "create"}, {"action": "move", "marker": "move", "place": {"id": "building1", "language": "english", "marker": "buildingConcept", "word": "building1"}, "thing": {"language": "english", "marker": "tankConcept", "types": ["tankConcept"], "id": "tank1id", "word": "tank1"}}],
  generators: [
    new Generator( ({global, context}) => context.marker.endsWith('Concept') && context.number > 0, ({g, context}) => `${g(context.number)} ${g(context.word)}` ),
    new Generator( ({global, context}) => context.marker == 'move', ({g, context}) => `move ${g(context.thing.word)} to ${g(context.place.word)}` ),
    new Generator( ({global, context}) => context.marker == 'create', ({g, context}) => `create ${g(context.klass)}` ),
  ],
  semantics: [
    new Semantic( ({global, context}) => context.pullFromContext
, ({global, context}) => { object = global.mentioned[0]
Object.assign(context, object)
delete context.pullFromContext
 } ),
    new Semantic( ({global, context}) => context.marker == 'create'
, ({global, context}) => { if (!global.newTanks) {
  global.newTanks = []
}
const tank = global.newTank()
if (!global.mentioned) {
  global.mentioned = []
}
global.mentioned.push({ marker: 'tankConcept', word: tank.name, id: tank.id })
 } ),
  ]
};